import { AfterViewInit, OnInit, EventEmitter, AnimationEntryMetadata } from '@angular/core';
import { FormControl } from '@angular/forms';
import { services } from 'typescript-angular-utilities';
import __object = services.object;
import __guid = services.guid;
import { FormComponent } from '../form/form';
export declare const baseInputs: string[];
export declare const baseOutputs: string[];
export declare const baseAnimations: AnimationEntryMetadata[];
export declare class InputComponent<T> implements AfterViewInit, OnInit {
    name: string;
    label: string;
    disabled: boolean;
    warning: boolean;
    value: T;
    labelState: string;
    hidePlaceholder: boolean;
    change: EventEmitter<T>;
    valueChange: EventEmitter<T>;
    inputType: string;
    control: FormControl;
    rlForm: FormComponent;
    protected object: __object.IObjectUtility;
    protected guid: __guid.IGuidService;
    constructor(rlForm: FormComponent, object: __object.IObjectUtility, guid: __guid.IGuidService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    initControl(): void;
    setValue(value: T): void;
    isLabelShowing(): boolean;
    showLabel(): void;
    hideLabelIfEmpty(): void;
}
